



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Springmvc_validation 效验器</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Springmvc_validation 效验器</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 03:26:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>springmvc-validation效验器的使用介绍</p>
<p>　　对于任何一个应用来说，都会做数据的有效性效验，但是只在前端做并不是很安全，考虑到安全性這个时候会要求我们在服务端也对数据进行有效验证，springmvc自身对数据在服务端有一个比较好的支持，springmvc能将我们前台提交的数据按照我们事先定下的规则，进行效验判断，对于不合格的数据信息，springmvc会把他保存到一个BindingResult 的类里面，这里面存放是错误集合，从而言之就可以把这些错误信息输出到jsp页面。</p>
<p><strong>使用validation接口进行验证：</strong></p>
<p>　　　　在我们注解驱动中注入validation 效验器&lt;mvc:annotation-driven conversion-service="conversionService" validator="validator"/&gt;</p>
<p><strong>所需依赖的jar包：</strong></p>
<p><strong>　　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1112417/201704/1112417-20170424085326084-808950757.png" /></strong></p>
<p><strong>springmvc配置参考：</strong></p>
<p><strong>　　</strong>这里我们指定了资源文件，以及一些常用配置，往后错误消息配置到CustomValidationMessage.properties 中以key value 形式读取</p>
<div>
<pre class="prettyprint linenums">  &lt;!--hibernate-validator 效验器<br />
          org.springframework.validation.beanvalidation.LocalValidatorFactoryBean 這个是spring-context 提供的效验的接口<br />
      --&gt;<br />
      &lt;bean id = "validator" class="org.springframework.validation.beanvalidation.LocalValidatorFactoryBean"&gt;<br />
          &lt;!-- hibernate的效验器 --&gt;<br />
              &lt;property name="providerClass" value="org.hibernate.validator.HibernateValidator" /&gt;<br />
          &lt;!-- 加载资源文件，在指定文件中配置错误信息如果不加载默认会去找classpath下的ValidationMessage.properties --&gt;<br />
              &lt;property name="validationMessageSource" ref ="messageSource"&gt;&lt;/property&gt;<br />
      &lt;/bean&gt;<br />
     &lt;bean id = "messageSource" class="org.springframework.context.support.ResourceBundleMessageSource"&gt;<br />
         &lt;!-- 加载资源文件名<br />
             basenames：不用加properties<br />
     --&gt;<br />
         &lt;property name="basenames"&gt;<br />
             &lt;list&gt;<br />
                 &lt;value&gt;classpath:CustomValidationMessage&lt;/value&gt;<br />
             &lt;/list&gt;<br />
         &lt;/property&gt;<br />
         &lt;!-- 资源文件的编码格式 --&gt;<br />
         &lt;property name="defaultEncoding" value="UTF-8"/&gt;<br />
         &lt;!-- 加载超时  秒 重新加载--&gt;<br />
         &lt;property name="cacheSeconds" value=""/&gt;<br />
     &lt;/bean&gt;</pre>
</div>
<p><strong>我们实体类pojo 的参考：</strong></p>
<div>
<pre class="prettyprint linenums">     //效验名称在1 到 10 字符之间 不建议在里面直接写message 建议写在配置文件里面以国际化方式去读取错误信息<br />
     @Size(min=2,max=10,message="{items.name.length.error}")<br />
     @NotNull(message="{items.name.isNull}")<br />
     private String name;<br />
     //非空的效验<br />
     @NotNull(message="{items.createtime.isNull}")<br />
     private Date createtime;

     @NotNull(message="{items.detail.isNull}")<br />
     private String detail;</pre>
</div>
<p><strong>controller代码参考：</strong></p>
<p><strong>　　</strong>在你需要效验的pojo前面添加@Validated 表示这是需要效验，在pojo 后面添加BindingResult 来接受它效验的错误信息</p>
<p>　　注意：@Validated 和BindingResult 是配对出现，一前一后方式，这本案例中只是简单实现了這个功能，但并不是完整的。</p>
<div>
<pre class="prettyprint linenums"> /**<br />
      *     商品信息提交的方法<br />
      * @return   重定向的使用<br />
      * @throws Exception<br />
      * @Validated: 注解效验器<br />
      * BindingResult：接受错误信息      */<br />
     @RequestMapping("/editItemsSubmit")<br />
     public String editItemsSubmit(Model model, Integer id,@Validated ItemsCustom itemsCustom ,BindingResult bindingResult)throws Exception{<br />
         if (bindingResult.hasErrors()) {<br />
             List&lt;ObjectError&gt; itemsErrorList = bindingResult.getAllErrors();<br />
             for(ObjectError objectError:itemsErrorList){<br />
                 System.out.println(objectError.getDefaultMessage());<br />
             }<br />
             model.addAttribute("itemsErrorList", itemsErrorList);<br />
             return "items/editItems";<br />
         }<br />
         // 调用service 里面的接口方法<br />
         itemsService.updateItems(id, itemsCustom);<br />
         // 使用重定向到<br />
         //    queryitems.do return "redirect:queryItems.do";<br />
         //使用forward  可以在其他页面获取值 对象等<br />
         //return "forward:queryItems.do";<br />
         return "success";<br />
     }</pre>
</div>
<p><strong>页面参JSP考代码：</strong></p>
<p><strong>　</strong>　测试代码打印出错误消息</p>
<div>
<pre class="prettyprint linenums">     &lt;c:if test="${itemsErrorList != null }"&gt;<br />
         &lt;c:forEach items="${itemsErrorList }" var="error" varStatus="index"&gt;<br />
             ${error.defaultMessage}<br />
         &lt;/c:forEach&gt;<br />
     &lt;/c:if&gt;</pre>
</div>
<p><strong>在资源文件中配置错误信息CustomValidationMessage.properties：</strong></p>
<div>
<pre class="prettyprint linenums"> # 配置效验器的错误信息，key value 形式<br />
                         # items 的错误配置<br />
3 items.name.length.error=请输入2到10个字符的商品名称！<br />
4 items.name.isNull=商品名称不能为空！<br />
5 items.createtime.isNull=请输入商品的生产日期!<br />
6 items.detail.isNull=商品描述不能为空！</pre>
</div>
<p><strong>Validation 效验常用限制注解：</strong></p>
<p><strong>　　@Null：限制只能为null</strong></p>
<p><strong>　　@NotNull：限制必须不能为空</strong></p>
<p><strong>　　@AssertFalse 限制必须为false</strong></p>
<p><strong>　　@AssertTrue 限制必须为true</strong></p>
<p><strong>　　@DecimalMax（value） 限制必须为一个不大于指定值得数字</strong></p>
<p><strong>　　@DecimalMax（value）限制必须为一个不小于指定值得数字</strong></p>
<p><strong>　　@Digits（integer，fraction）限制必须为一个小数，且整数部分的位数不能超过integer，小数部分不能超过fraction</strong></p>
<p><strong>　　@Futrue 限制必须为一个将来的日期</strong></p>
<p><strong>　　@Max（value） 限制必须为一个不大于指定值得数字</strong></p>
<p><strong>　　@Min（value）限制必须为一个不小于指定值得数字</strong></p>
<p><strong>　　@Past限制必须为一个过去的时间</strong></p>
<p><strong>　　@Pattern（value）限制为符合指定的正则表达式</strong></p>
<p><strong>　　@Size（max，min）限制字符长度在min 到 max 之间</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqde0mv9.html">Linux命令-文件文本操作grep</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kpy3j9.html">canvas图片处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/495myk6q.html">利用spring boot创建java app</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxejv08.html">使用Support Vector Machine</a>
		</li>
						<li><a href="https://www.batexi.com/a/39054r3q.html">QTreeWidget</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdv34xq.html">js作用域学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7ylwgq.html">10月9日Android学习笔记：活动与服务之间的通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv6v5x8.html">a 标签中调用js的几种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jky0w8.html">【POJ】1113 Wall（凸包）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vm24n8.html">2014年2月份第4周51Aspx源码发布详情</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zroj49.html">CentOS7 安装MongoDB 3&period;0服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdewme09.html">SmartWiki开发日记之Laravel缓存扩展</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdornr8.html">Android开发者应该深入学习的10个开源应用项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ml6lkq.html">Win7环境下VS2010配置Cocos2d-x-2&period;1&period;4最新版本号的开发环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x454z9.html">DEDE常见的错误（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk1nwe8.html">3-STM32带你入坑系列&lpar;自己封装点亮一个灯的库--Keil&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2dm2oq.html">Django Rest framework基础使用之 serializer</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwrpgz9.html">Redux的梳理</a>
		</li>
						<li><a href="https://www.batexi.com/a/960vm7y9.html">关于&OpenCurlyDoubleQuote;最小的K个数&rdquo;问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zklnl38.html">20165320 实验一 java环境的熟悉</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qy1gxemq.html">ASP&period;NET前台table通过Ajax获取绑定后台查询的json数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkyroz8.html">Python基础学习 --  列表与元组</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pdkx38.html">&lbrack;补档&rsqb;&lbrack;Poi2014&rsqb;FarmCraft</a>
			</li>
						<li><a href="https://www.batexi.com/a/9geg6pe8.html">C&plus;&plus; STL Binary search详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjwp0k8.html">C&num;之异步</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljvdzx9.html">GPUImage原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljv0k69.html">模拟实现C库的atoi、atof和itoa</a>
			</li>
						<li><a href="https://www.batexi.com/a/90my5nn8.html">swift 获取文件的Md5值</a>
			</li>
						<li><a href="https://www.batexi.com/a/950dkx08.html">Http跨域时的Option请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpk4y0q.html">Form表单中method&equals;post&sol;get两种数据传输的方式的区别</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
